;***************************************************************
;* Project Name:
;* Project Description :
;
;* Author:
;* Lab_group: <merocsoprt jele>
;* Last edited: <Enter the date here> 
;
;***************************************************************
;* "AVR ExperimentBoard" port assignment information:
;***************************************************************
;*
;* LED0(P):PortC.0          LED4(P):PortC.4
;* LED1(P):PortC.1          LED5(P):PortC.5
;* LED2(S):PortC.2          LED6(S):PortC.6
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4
;*
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3
;*
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7
;*
;***************************************************************
;*
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3
;*
;***************************************************************
;*
;* LCD1(VSS) = GND         LCD9(DB2): -
;* LCD2(VDD) = VCC         LCD10(DB3): -
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6
;* LCD6(E  ) = PortA.1     LCD14(DB7): PortA.7
;* LCD7(DB0) = -           LCD15(BLA): VCC
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)
;*
;***************************************************************

.include "m128def.inc" ; Definition file for ATmega128    
;* Program Constants
.equ const =$00 ; Generic Constant Structure example 
;* Program Variables Definitions
.def temp =r16 ; Temporary Register example

;***************************************************************
;* Reset & Interrupt Vectors 
.cseg
.org $0000 ; Define start of Code segment
 jmp RESET ; Reset Handler, jmp is 2 word instruction    

 reti ; INT0 Handler on $0002, dummy
 nop
 reti ; INT1 Handler, if INTn used, 'reti' and 'nop'
      ; will be replaced by 'jmp INTn_Handler_Address'
 nop
 reti ; INT2 Handler
 nop
 reti ; INT3 Handler
 nop
 reti ; INT4 Handler
 nop
 reti ; INT5 Handler
 nop
 reti ; INT6 Handler
 nop
 reti ; INT7 Handler
 nop
 reti ; Timer2 Compare Match Handler
 nop
 reti ; Timer2 Overflow Handler
 nop
 reti ; Timer1 Capture Event Handler
 nop
 reti ; Timer1 Compare Match A Handler
 nop
 reti ; Timer1 Compare Match B Handler
 nop
 reti ; Timer1 Overflow Handler
 nop
 ;reti ; Timer0 Compare Match Handler
 ;nop
 jmp TIMER_IT1
 reti ; Timer0 Overflow Handler
 nop
 reti ; SPI Transfer Complete Handler
 nop
 reti ; USART0 RX Complete Handler
 nop
 reti ; USART0 Data Register Empty Hanlder
 nop
 reti ; USART0 TX Complete Handler
 nop
 reti ; ADC Conversion Complete Handler
 nop
 reti ; EEPROM Ready Hanlder
 nop
 reti ; Analog Comparator Handler
 nop
 reti ; Timer1 Compare Match C Handler
 nop
 reti ; Timer3 Capture Event Handler
 nop
 reti ; Timer3 Compare Match A Handler
 nop
 reti ; Timer3 Compare Match B Handler
 nop
 reti ; Timer3 Compare Match C Handler
 nop
 reti ; Timer3 Overflow Handler
 nop
 reti ; USART1 RX Complete Handler
 nop
 reti ; USART1 Data Register Empty Hanlder
 nop
 reti ; USART1 TX Complete Handler
 nop
 reti ; Two-wire Serial Interface Handler
 nop
 reti ; Store Program Memory Ready Handler
 nop
 
;***************************************************************
;* MAIN program, Initialisation part
.org $0046;
M_INIT:
RESET:
;* Stack Pointer init,
;  Set stack pointer to top of RAM
 ldi temp, LOW(RAMEND) ; RAMEND = max address in RAM"
 out SPL, temp        ; RAMEND value in "m128def.inc"
 ldi temp, HIGH(RAMEND)
 out SPH, temp

;< Insert your other initialisation code here>

;***************************************************************
;* MAIN program, Endless loop part
 

;;********************** INIT **********************************
 ldi r31,0 // a szmlls irnyt meghatroz regiszter ha nem 0 "elrefele" szmol
 ldi r30,0  // mennyit kell vrni...
 ldi r29,0 // ciklus szmll a vrakozshoz
 ldi r28,0 // ciklus szmll a 10Hz-hez ciklushoz
 ldi r27,0 // az rtk amit shiftelgetnk, s kiirunk a PORTC -re

;;********************* KI-BE meneti portok*********************
 ldi r16,0xFF
 out DDRC, r16 ; kimenetre lltjuk a C portot

 ldi temp, 0b01100011   ;// az utols kt bit 01 = Vref == Vacc, ADLAR = 1 a knyebb kezels miatt
 out ADMUX, temp    ;// s ADC3 engedlyzse,single ended, fldelt cuccot mrnk

 ldi temp, 0b11100000  ;// ADC: engedlyezs, freerunning mode,free run select
 out ADCSR, temp


;;*********************** TIMER0 belltsa*********************
 ldi r16,0b00001111
 out TCCR0,temp ; Timer 0 TCCR0 regiszter
 ldi temp,216   ; 50 Hz
 out OCR0,temp ; Timer 0 OCR0 regiszter

 ldi temp,0b00000010
 out TIMSK,temp ; Timer IT Mask regiszter
 
 sei ; globlis IT engedlyezve

 

;;*********************** F CIKLUS ***************************
M_LOOP:

  in r16,ADCL ;nem hasznljuk de ki kell olvasni a free run md miatt
  in r16,ADCH 
  
  cpi r16,128
  brsh HATRAFELE
ELOREFELE:  
  ; 127 - 0
  ldi r31,0xFF 
  lsl r16 ; *= 2  
  call DIV_BY_17
  mov r30,r16
  
  jmp UTEMEZES_VEGE  

HATRAFELE:
  ; 128 - 255
  ldi r31,0
  subi r16,127
  lsl r16
  call DIV_BY_17

  ldi r17,16  ; megfordtjuk az ismtlsi mennyisget 1->15
  sub r17,r16
  mov r30,r17
  
UTEMEZES_VEGE:  
 call DO_WAIT;
 
 jmp M_LOOP ; Endless Loop   

;***************************************************************
;* Subroutins, Interrupt routins

; timer interrupt handler
TIMER_IT1:
 push r16
 in r16,SREG
 push r16
 push r17

 cpi r28,5
 brlo DONT_DO1
 ; 10 HZ 
  cpi r29,0
  brne VARAKOZAS

   or r31,r31 ; szmlls irnynak az eldntse
   breq HATRA
  
  ELORE:
   lsr r27
   mov r17,r27
   andi r17,1
   brne KIIR
   ori r27,0b10000000
   jmp KIIR 
  
  HATRA:
   lsl r27
   mov r17,r27
   andi r17,0b10000000
   brne KIIR 
   ori r27,1  
  
  KIIR:
   out PORTC,r27   
  
  mov r29,r30
 VARAKOZAS:  
  dec r29   
  
 ldi r28,0 
DONT_DO1:
 inc r28

 pop r17
 pop r16
 out SREG, r16
 pop r16

 reti

;****************************************************************
;      oszt szubrutin

; r16 ban lev szmot osztja el, az eredmnyt is ebben a regiszterben adja vissza
DIV_BY_17:
 push r17
 
 ldi r17,1
OSZTO_CIKLUS:
 cpi r16,17
 brlo OSZTAS_VEGE
 subi r16,17
 inc r17
 jmp OSZTO_CIKLUS
OSZTAS_VEGE:
 mov r16,r17
  
 pop r17
 ret

;****************************************************************
;      Vrakoz szubrutin
DO_WAIT:
 push r17
 push r18 
  ldi r17,0
 LOOP0:
  
   ldi r18,0
  LOOP1:
   dec r18
   brne LOOP1  

  dec r17
  brne LOOP0
 
 pop r18
 pop r17
 ret